function string:split(sSeparator, nMax, bRegexp)
	assert(sSeparator ~= '')
	assert(nMax == nil or nMax >= 1)

	local aRecord = {}

	if self:len() > 0 then
		local bPlain = not bRegexp
		nMax = nMax or -1

		local nField=1 nStart=1
		local nFirst,nLast = self:find(sSeparator, nStart, bPlain)
		while nFirst and nMax ~= 0 do
			aRecord[nField] = self:sub(nStart, nFirst-1)
			nField = nField+1
			nStart = nLast+1
			nFirst,nLast = self:find(sSeparator, nStart, bPlain)
			nMax = nMax-1
		end
		aRecord[nField] = self:sub(nStart)
	end

	return aRecord
end
--
-- Print anything - including nested tables
function tprint (tt, indent, done)
	if type(tt) == "table" then
		done = done or {}
		indent = indent or 0
		for key, value in pairs (tt) do
			io.write(string.rep (" ", indent)) -- indent it
			if type (value) == "table" and not done [value] then
				done [value] = true
				io.write(string.format("[%s] => table\n", tostring (key)));
				io.write(string.rep (" ", indent+4)) -- indent it
				io.write("(\n");
				tprint (value, indent + 7, done)
				io.write(string.rep (" ", indent+4)) -- indent it
				io.write(")\n");
			else
				io.write(string.format("[%s] => %s\n",
						tostring (key), tostring(value)))
			end
		end
	else
		io.write(tostring(tt) .. "\n")
	end
end

function stprint (tt, indent, done)
	str = ''
	if type(tt) == "table" then
		done = done or {}
		indent = indent or 0
		for key, value in pairs (tt) do
			str = str .. string.rep(' ', indent)
			if type (value) == "table" and not done [value] then
				done [value] = true
				str = str .. string.format('[%s] => table\n', tostring(key)) ..
						string.rep(' ', indent+2) .. '(\n' ..
						stprint(value, indent+4, done) ..
						string.rep(' ', indent+2) .. ')\n'
			else
				str = str .. string.format('[%s] => %s\n', tostring(key), tostring(value))
			end
		end
	else
		str = tostring(tt) .. "\n"
	end
	return str
end

-- overloads default print
function print ( ... )
	for _,v in ipairs(arg) do
		tprint(v)
	end
end
