cm = {}
cm.menu = {
	 {
		label = "Jump",
		id = "jump",
		primary = "",
		secondary = "",
	},
	{
		label = "Move left",
		id="left",
		primary = "",
		secondary = "",
	},
	{
		label = "Move right",
		id="right",
		primary = "",
		secondary = "",
	}
}

local update = function (self, dt)
end

--draws header for the key bind table
local drawHeader = function (self, fontSize)
	love.graphics.print("Action", cm.x, cm.y)
	love.graphics.print("Primary", cm.xPr, cm.y)
	love.graphics.print("Secondary", cm.xSe, cm.y)
	cm.y = cm.y + fontSize + (fontSize / 5)
	love.graphics.print("---------", cm.x, cm.y)
	love.graphics.print("-----------", cm.xPr, cm.y)
	love.graphics.print("--------------", cm.xSe, cm.y)
	cm.y = cm.y + fontSize + (fontSize / 5)
end

--draws key bind table element
local drawBind = function (self, value, fontSize)
		love.graphics.setColor(255, 0, 255, 255)
		love.graphics.print(value.label, cm.x, cm.y)
		love.graphics.print(value.primary, cm.xPr, cm.y)
		love.graphics.print(value.secondary, cm.xSe, cm.y)
		cm.y = cm.y + fontSize + (fontSize / 5)
end

local draw = function (self)
	cm.x = love.graphics.getWidth()/10
	cm.xPr = cm.x + 330
	cm.xSe = cm.xPr + 260
	cm.y = love.graphics.getHeight()/4
	fontSize = love.graphics.getHeight() / 13
	--font = love.graphics.newFont("fonts/controlMenu.woff", 12)
	--love.graphics.setFont(font)
	love.graphics.setFont(fontSize)
	drawHeader(self, fontSize)
	for key, value in ipairs(cm.menu) do
		drawBind(self, value, fontSize)
	end
end

function newControlMenu(controlOptions, control)
	cm.controlOptions = controlOptions
	cm.control = control
	cm.active = 0
	for key, value in ipairs(cm.menu) do
		
	end
	return setmetatable( {
			update = update,
			draw = draw,
		}, nil
	)
end

