local ending = {
	theEnd = false,
	startTime = 0,
	--scren shot stuff
	screenShot = false,
	centerPX = 0,
	centerPY = 0,
	sssX = 1, -- screen shot scale X
	sssY = 1, -- screen shot scale X
	sscX = 0, -- screen shot center x
	sscY = 0, -- screen shot center y
	ssF = 255, -- screen shot fade
	ssInvisible = false,
	freezed = false, --freezed for a short
	imgPerspective = false,

}

local ssCenter = function (self)
	local ending = self.ending
	if not ending.ssInvisible then
		ending.sscX = ending.screenShot:getWidth()/2 - ending.screenShot:getWidth()/2 * ending.sssX
		ending.sscY = ending.screenShot:getHeight()/2 - ending.screenShot:getHeight()/2 * ending.sssY
		--print("cX: "..ending.sscX.."cY: "..ending.sscY)
	end
end

local update = function (self, dt)
	local ending = self.ending
	local curTime = love.timer.getTime()
	local diff = curTime - ending.startTime

	if ending.sssX > 0.2 then
		if (ending.freezed or diff > 2) then
			--freeze for 2 sec
			if not ending.freezed then
				ending.freezed = true
				ending.startTime = ending.startTime + diff
			end
			--zoom out
			ending.sssX = 1*(100-diff*15)/100
			ending.sssY = ending.sssX
			--fade away
			if ending.sssX < 0.6 then
				ending.ssF = ending.ssF - 1
			end
		end
	else
		ending.ssInvisible = true		
	end
	--center screen shot
	ssCenter(self)
	
	print("testing: "..diff.." scale: x="..ending.sssX.." y="..ending.sssY)
end

local drawPhase1 = function (self)
	local ending = self.ending
	--almost filming mechanism implemented in commented part during tests :)))
	--if not ending.test then	
		----identity should be called only once
		--love.filesystem.setIdentity("screenshots")
		----loop for filming
		--test = love.image.newEncodedImageData(ending.screenShotData, "bmp")
		--smth = love.filesystem.write("test"..ending.count..".bmp", test)
		--ending.test = true
		--ending.count = ending.count + 1
		--end
	--end
	--x, y, r, sx, sy, ox, oy
	love.graphics.setColor(255,255,255, 255)
	love.graphics.draw(ending.imgPerspective, -ending.centerPX/2, -ending.centerPY/2, 0, 1, 1, 0, 0)
	if not ending.ssInvisible then
		love.graphics.setColor(255,255,255, ending.ssF)
		love.graphics.draw(ending.screenShot, ending.sscX, ending.sscY, 0, ending.sssX, ending.sssX, 0, 0)
		--love.graphics.draw(ending.screenShot, ending.sscX, ending.sscY, 0, ending.sssX, ending.sssX, 0, 0)
	end
end

local startTheEnd = function (self)
	local ending = self.ending
	if not ending.theEnd then
		ending.startTime = love.timer.getTime()
		--otherwise it draws black screen
		ending.screenShotData = love.graphics.newScreenshot( )
		ending.screenShot = love.graphics.newImage(ending.screenShotData)
		ending.imgPerspective = love.graphics.newImage("assets/snake.png")
		ending.centerPX = 1024 --2048
		ending.centerPY = 800 --1024
		GAME_STATE = "end"
		ending.theEnd = true
	end
end


local draw = function (self)
	local ending = self.ending
	if ending.theEnd then
		drawPhase1(self)
	end
end

function newEnding()
	return setmetatable({
			ending = ending,
			update = update,
			startTheEnd = startTheEnd,
			draw = draw,
		}, nil
	)
end

