-- I am cold and need to sleep
-- function, that loads map lvl and spawns hero at tile tx, ty
function loadLvl(lvl, tx, ty, lxoff, lyoff)
	-- first delete old objects if any
	hash = SHWrap(200)

	--load map stuff
	if '7' ~= lvl then
	bgImg_1 = love.graphics.newImage('assets/bg_'..lvl..'_1.jpg')
	bgImg_2 = love.graphics.newImage('assets/bg_'..lvl..'_2.jpg')
	end
	if mapper.old_fn then
		local s = mapper.save_objects(map.objects)
		love.filesystem.write(mapper.old_fn:split('.')[1]:split('/')[2] .. '.osd', s)
	end
	mapper.load('assets/snakeworld'..lvl..'.tmx')
	bgxoff = lxoff or 0
	bgyoff = lyoff or 0
	mapper.ready_layers()
	local p = mapper.old_fn:split('.')[1]:split('/')[2]
	-- if we already have visited this map, load objects from last visited state
	if love.filesystem.isFile(p .. '.osd') then
		f = love.filesystem.read(p .. '.osd')
		local s, e = loadstring('return ' .. f)
		if not s then
			print(e)
		end
		map.objects = s()
		mapper.reg_missing_obj_tiles(map.objects.obj)
	end
	mapper.hash_walls(hash)

	
	AI:load()
	gc('collect')
	-- reinserts yourself
	hero:reset(tx * tonumber(map.tilew), ty * tonumber(map.tileh))
	hash:insert(hero)
	-- needed because of long map loading time..
	GAME_STATE = 'loading'
	skip_frame = 2

end

function clamp(val, min, max)
	return val < min and min or (val > max and max or val)
end

function inrange(val, min, max)
	return val > min and val < max
end

-- custom mapper vars and functions
mapper.consumable = {
	['cmax'] = 1,
	['lesser'] = 1,
	['bigger'] = 2,
}

mapper.acorns = {
	['earth acorn'] = 0.8,
	['fire acorn'] = 0.7,
	['wind acorn'] = 0.7,
	['water acorn'] = 0.6,
	['ice acorn'] = 0.4,
}

mapper.asset_path = 'assets/'
mapper.sign_text_width = 200
mapper.sign_offset = vector(-62, 0)

function mapper.hash_walls(hash)
	if map.collisions then
		for typ,table in pairs(map.collisions) do
			-- do some type check with typ
			for i,v in ipairs(table) do
				hash:insert(v)
			end
		end
	end
	
	-- needed to comment out, because bots don't work
	-- but need to fix, because cant pick up cheese
	if map.objects.obj then
		for typ,table in pairs(map.objects.obj) do
			if typ ~= 'bot' then
				for i,val in ipairs(table) do
					hash:insert(val)
				end
			end
		end
	end

end

function mapper.drawCollisions(camx, camy)
--	camx,camy = camx-mapper.hscreen_w,camy-mapper.hscreen_h
	if 1 == watcher.visible then
		love.graphics.setColor(0xff, 0x00, 0xa0, 0x70)
		for k,v in pairs(map.collisions.wall) do
			love.graphics.rectangle('fill', v.pos.x + mapper.hscreen_w, mapper.hscreen_h + v.pos.y , v.shape.x, v.shape.y)
		end
		love.graphics.setColor(0x00, 0xff, 0xa0, 0x70)
		love.graphics.rectangle('fill', camx + mapper.hscreen_w, mapper.hscreen_h + camy, hero.shape.x, hero.shape.y)
		if nil ~= map.collisions.platform then
			love.graphics.setColor(0, 0xa7, 0xa0, 0x70)
			for k,v in pairs(map.collisions.platform) do
				love.graphics.rectangle('fill', v.pos.x + mapper.hscreen_w, v.pos.y + mapper.hscreen_h, v.shape.x, v.shape.y)
			end
		end
		love.graphics.setColor(0xff, 0xff, 0x10, 0x70)
		for k,v in pairs(map.objects.obj) do
			for i,val in ipairs(v) do
				love.graphics.rectangle('fill', val.pos.x + mapper.hscreen_w, val.pos.y + mapper.hscreen_h, val.shape.x, val.shape.y)
			end
		end
	end
end

-- using framebuffers for framebuffers
--
--
-- not using yet, as ot somewhy does't draw 32x32 objects in the middle of 64x64
-- tile
function ready_objects()
	local map_height = mapper.pmap_height
	local map_width = mapper.pmap_width
	local fbmax = mapper.fbmax
	local no_of_rows = math.floor(map_height / fbmax)
	local no_of_cols = math.floor(map_width / fbmax)
	local tid, tset, ol_tset
	local objs = 'objects'
	static[objs] = {}
	love.graphics.setColor(0xff, 0xff, 0xff, 0xff)
	for typ,v in pairs(map.objects.obj) do
		if typ ~= 'bot' then
			for i,tab in ipairs(v) do
				tset = map.tile[tab.tid].tileset
				locy = math.floor(tab.pos.y / fbmax) * fbmax
				if not static[objs][locy] then
					static[objs][locy] = {}
				end
				locx = math.floor(tab.pos.x / fbmax) * fbmax
				if not static[objs][locy][locx] then
					local _fb = love.graphics.newFramebuffer(fbmax, fbmax)
					static[objs][locy][locx] = {
						fb = _fb
					}
				elseif ol_tset ~= tset then
					-- ok, this part is very very very hack
					-- so much of a hack I think this is worth some attention
					--
					-- when drawing with quads from different sources to
					-- changing framebuffers, love seems to remember only latest
					-- source information, so every time source file changes
					-- we create new frame buffer and draw contents of previous
					-- FB to new one as an image, and then assign this new FB to
					-- old FB name
					--
					-- ok, this doesn't work unless you redraw every frame...
					local _fb = love.graphics.newFramebuffer(fbmax, fbmax)
					love.graphics.setRenderTarget(_fb)
					love.graphics.draw(
						love.graphics.newImage(
							static[objs][locy][locx].fb:getImageData()
						),
						0,
						0
					)
					static[objs][locy][locx].fb = _fb
					print('this is executed everytime')
					print(tab)
					print(locy .. ' ' .. locx .. ' ' .. tset .. ' ')
				end
				love.graphics.setRenderTarget(static[objs][locy][locx].fb)
				love.graphics.drawq(
					map.tileset[ tset ].src,
					map.tile[ tab.tid ].q,
					tab.pos.x - locx,
					tab.pos.y - locy
				)
				love.graphics.present()
			end
		end
	end
	love.graphics.setRenderTarget()
end
				
	

-- to be used with 'get_objects'
function draw_objects(camx, camy)
	for y,vy in pairs(static['objects']) do
		for x,vx in pairs(vy) do
--			print(x .. ' ' .. y .. ' ' .. camx .. ' ' .. camy)
--			print(vx)
			love.graphics.draw(
				vx.fb,
				x + mapper.hscreen_w,
				y + mapper.hscreen_h
			)
		end
	end
--	print('--')
end

function mapper.draw_objects_directly(camx, camy)
	local tset
	if map.objects.obj then
		for typ,v in pairs(map.objects.obj) do
			-- lets not draw bot starting points
			if 'bot' ~= typ then
				for i,tab in pairs(v) do


-- yes, I know checking code here is visually ugly..
if		inrange( tab.pos.x, camx - mapper.hscreen_w - tab.shape.x, camx + mapper.hscreen_w)
	and
		inrange( tab.pos.y, camy - mapper.hscreen_h - tab.shape.y, camy + mapper.hscreen_h)
	then

	tset = map.tile[ tab.tid ].tileset
	love.graphics.drawq(
		map.tileset[ tset ].src,
		map.tile[ tab.tid ].q,
		tab.pos.x + mapper.hscreen_w,
		tab.pos.y + mapper.hscreen_h
		)
end


				end
			end
		end
	end
end

function cleanup_lvldata()
	local p = 'snakeworld'
	for i=1,7 do
		if love.filesystem.isFile(p .. i .. '.osd') then
			-- love.filesystem.remove oesn't work for some mysterious reason
			love.filesystem.remove(p .. i .. '.osd')
		end
	end
	love.filesystem.setIdentity('.')
	love.filesystem.remove('semiou')
end

function insert_object(obj)
	if not map.objects.obj[ obj.type ] then
		map.objects.obj[ obj.type ] = {}
	end
	table.insert(map.objects.obj[ obj.type ], obj)
end

function generate_tile_id(name, posx, posy)
	local tsetid 
	for k,v in pairs(map.tileset) do
		if name == v.name then
			tsetid = k
			break
		end
	end
	local r = math.floor(posy / map.tileset[ tsetid ].tileh)
	local c = math.floor(posx / map.tileset[ tsetid ].tilew)
	local tid = c + r * map.tileset[ tsetid ].coln
	local gtid = tid + map.tileset[ tsetid ].firstid
	if not map.tile[ gtid ] then
		map.tile[ gtid ] = {
			tileset = tsetid
		}
		map.tile[ gtid ].q = love.graphics.newQuad(
			c * map.tileset[ tsetid ].tilew, r * map.tileset[ tsetid ].tilew,
			map.tileset[ tsetid ].tilew, map.tileset[ tsetid ].tileh,
--			map.tileset[ tsetid ].width, map.tileset[ tsetid ].height
			map.tileset[ tsetid ].src:getWidth(), map.tileset[ tsetid ].src:getHeight()
			)
	end
	return gtid
end

function generate_iceblock(where, shape)
	local iceblock = {
		pos = where,
		shape = shape,
		type = 'iceblock',
	}
	iceblock.tid = generate_tile_id('bones', 0, 4*64)
	insert_object(iceblock)
	hash:insert(iceblock)
end

function mapper.show_sign(obj)
	if obj then
		local dfont = love.graphics.getFont()
		love.graphics.setFont(sign_font)
		local w, l = sign_font:getWrap(
			obj.properties.msg,
			mapper.sign_text_width
		)
		love.graphics.setColor(120, 255, 43, 255)
		love.graphics.printf(
			obj.properties.msg,
			obj.pos.x + mapper.sign_offset.x + mapper.hscreen_w,
			obj.pos.y + mapper.sign_offset.y - l * 24 + mapper.hscreen_h,
			mapper.sign_text_width,
			'center'
		)
		love.graphics.setColor(0xff, 0xff, 0xff, 0xff)
		love.graphics.setFont(dfont)
	end
end
