local magus = require('magic')

local function can_collide(self, with)
	if		with == 'wall' or
			with == 'lbot' or
			with == 'platform' then
		return true
	end
	return false
end

local function get_jump_power(self)
	return self.jump_power*math.pow(2, -self.jump_count/self.max_jump)
end

-- function for hero to get hit
local function gethit(self, how_much)
	if self.hit_time <= 0 then
		self.health = self.health - how_much
		self.hit_time = self.max_invic
		self.doknockback = true
		audio:play(6, false, 1)
	end
end

local function collide(self, hash)
	local set = hash:getNeighbours(self, self.pos - self.shape/2, self.pos + self.shape * 1.5)
	-- get hit
	if self.hit_time <= 0 then
		for _,other in pairs(set) do
			if		'spikes' == other.type or
					'fire' == other.type or
					'feather' == other.type or
					'acid' == other.type or
					'wood' == other.type then
					-- softening hack
					if vec2vec(self.disp, self.shape, other.pos+ vector(10, 5), other.shape - vector(20, 10)) then
						self:gethit(1)
					end
			end
			if 'lbot' == other.type then
				if vec2vec(self.disp, self.shape, other.pos + vector(5,33), other.shape - vector(10,38)) then
					self:gethit(1)
				end
			end
		end
	end
	-- check if standing on walls
	local opos, oshape, coll
	for _,other in pairs(set) do
		coll = false
		-- lets generate offsets for each type
		if		'wall' == other.type or
				'iceblock' == other.type or
				'platform' == other.type then
			opos = other.pos
			oshape = other.shape
			coll = true
		end
		-- softening hack
		if		'stone' == other.type or
				'wood' == other.type then
			opos = vector(other.pos.x + 10, other.pos.y + 5)
			oshape = vector(other.shape.x - 20, other.shape.y - 10)
			coll = true
		end
		if	'lbot' == other.type then
			opos = vector(other.pos.x + 5, other.pos.y + 33)
			oshape = vector(other.shape.x - 10, other.shape.y - 38)
			coll = true
		end

		-- now lets do actual collision check and correction
		if coll then
			if standon(self, opos, oshape) then
				self.vel.y = 0
				self.jump_count = 0
				if 'jump' == hero.state then
					hero.state = 'stand'
						hero.vel.x = 0
				else
					if math.abs(hero.vel.x) < 5 then
						hero.state = 'stand'
						hero.vel.x = 0
					end
				end
			end
			if 'platform' ~= other.type then
				nearwall(self, opos, oshape)
			end
		end
		if 'sign' == other.type then
			if box2box(self, other.pos, other.shape) then
				self.sign = other
			end
		end

	end
	-- assuming hero can't collide with ground and then with ceilings
	if 0 ~= self.jump_count then
		for _,other in pairs(set) do
			if can_collide(self, other.type) or
					'stone' == other.type or
					'wood' == other.type or
					'iceblock' == other.type or
					'feather' == other.type then
					if 'platform' ~= other.type then
						if ceilinggravity(self, other.pos, other.shape) then
							self.vel.y = 0
							return
						end
					end
			end
		end
	end
	-- interactions here

	self.inwater = false
	for _,other in pairs(set) do
			
		-- lets check if we are in water
		if 'water' == other.type then
			if box2box(self, other.pos, other.shape) then
				self.inwater = true
			end
		end
		if	nil ~= mapper.consumable[ other.type ] then
			if box2box(self, other.pos, other.shape) then
				if 'cmax' == other.type then
					self.max_health = self.max_health + mapper.consumable[other.type]
					self.health = self.max_health
					hash:remove(other)
					mapper.removeobj(other)
				else
					if self.health ~= self.max_health then
						self.health = self.health + mapper.consumable[other.type]
						self.health = self.health > self.max_health and self.max_health or self.health
						hash:remove(other)
						mapper.removeobj(other)
						audio:play(7, false, 1)		-- consume sound
					end
				end
			end
		end
		if nil ~= mapper.acorns[other.type] then
			if box2box(self, other.pos, other.shape) then
				self.magics[other.type:match('(%a+)')] = mapper.acorns[other.type]
				local t = other.type:match('(%a+)')
				hud:addDynamic(t)
				if 'water' == t then
					hud:addStatic('s_ice')
				elseif 'wind' == t then
					hud:addStatic('s_wind')
					self.max_jump = self.max_jump + 1
				end
				hash:remove(other)
				mapper.removeobj(other)
			end
		end
		
		-- load other map
		if 'teleport' == other.type then
			if box2box(self, other.pos, other.shape) then
				local hx, hy = other.properties.dest:match('(%d+),(%d+)')
				hx, hy = tonumber(hx), tonumber(hy)
				if '99' == other.properties.map then
					ending:startTheEnd()
					hero:reset()
				else
					loadLvl(other.properties.map, hx, hy, other.bgoxxf, other.bgoffy)
				end
			end
		end
			
	end
	if nil ~= self.m then
		local set = hash:getNeighbours(self.m)
		for _,other in pairs(set) do
			-- do damage to bots
			if 'lbot' == other.type then
				if box2box(self.m, other.pos, other.shape) then
					if 'imagic' == self.m.type then
						generate_iceblock(other.pos, other.shape)
					end
					AI:remove(other)
				end
			end
			if 'fmagic' == self.m.type then
				if		'wood' == other.type or
						'iceblock' == other.type 
					then
					if box2box(self.m, other.pos, other.shape) then
						hash:remove(other)
						mapper.removeobj(other)
						self.fupdate = true
					end
				end
			end
			if 'wmagic' == self.m.type then
				if 'fire' == other.type then
					if box2box(self.m, other.pos, other.shape) then
						hash:remove(other)
						mapper.removeobj(other)
						self.fupdate = true
					end
				end
			end
			if 'gmagic' == self.m.type then
				if 'feather' == other.type then
					if box2box(self.m, other.pos, other.shape) then
						hash:remove(other)
						mapper.removeobj(other)
						self.fupdate = true
					end
				end
			end
			if 'emagic' == self.m.type then
				if 'stone' == other.type then
					if box2box(self.m,  other.pos, other.shape) then
						hash:remove(other)
						mapper.removeobj(other)
						self.fupdate = true
					end
				end
			end
			if 'imagic' == self.m.type then
				if 'acid' == other.type then
					if box2box(self.m, other.pos, other.shape) then
						hash:remove(other)
						generate_iceblock(other.pos, other.shape)
						mapper.removeobj(other)
						self.fupdate = true
					end
				end
			end
		end

		-- cold + water == ice		- logical
		if self.inwater and 'imagic' == self.m.type then
			local taken = false
			-- yes, this not very computation nice.. but, can't do
			-- better
			for _, doubleother in pairs(set) do
				if 'iceblock' == doubleother.type then
					if box2box(self.m, doubleother.pos, doubleother.shape) then
						taken = true
						break
					end
				end
			end
			if not taken then
				generate_iceblock(
					vector(self.m.pos.x, self.m.pos.y),
					vector(64, 64)
				)
				self.fupdate = true
			end
		end
	end
end

local function update(self, dt, hash)

	self.sign = nil
	local oforce = self.force
	if self.inwater then
		dt = dt/3*2
	end
	phys1(self, dt)

	self.fupdate = false
	collide(self, hash)
	if self.hit_time > 0 then
		self.hit_time = self.hit_time - dt
	end
	if self.inwater then
		if  not self.magics['water'] then
			self.health = 0
		end
		applyForce(self, -oforce.x/2, -oforce.y/2)
	end
	phys2(self, hash)
	if nil ~= self.m then
			self.m:updatem(self, dt, hash)
	end

	hero.vel.x = clamp(hero.vel.x, -200, 200)

	-- animation updates
	self.walkAni:update(dt)
	if self.doknockback then
		self.vel.x = -100*self.dir
		self.vel.y = -200
		self.state = 'jump'
		self.jump_count = self.max_jump
	end
	self.doknockback = false
	
	-- kill hero if healt reaches 0
	if self.health == 0 then
		self.health = self.max_health
		audio:play(13, false, 1)
		loadLvl(1, 2, 5, 0, 0)	-- back to start
	end
	
end

local function draw(self)
	if self.hit_time > 0 then
		love.graphics.setColor(0xff, 50, 50)
	else
		love.graphics.setColor(255, 255, 255)
	end
	camx = clamp(hero.pos.x, 0, mapper.hscreen_w)
	if hero.pos.x > mapper.pmap_width - mapper.hscreen_w then
		camx = hero.pos.x - mapper.pmap_width + mapper.hscreen_w*2
	end
	camy = clamp(hero.pos.y, 0, mapper.hscreen_h)
	if hero.pos.y > mapper.pmap_height - mapper.hscreen_h then
		camy = hero.pos.y - mapper.pmap_height + mapper.hscreen_h*2
	end
	
	watcher.watch(1, camx .. ' ' .. camy)
	love.graphics.push()
	love.graphics.translate(camx, camy)
	--love.graphics.rectangle('fill', mapper.hscreen_w, mapper.hscreen_h, self.shape.x, self.shape.y)
	if self.state == "walk" then
		if self.dir == 1 then
			self.walkAni:draw(- self._off.x,  - self.offset.y, 0, self.dir, 1)
		else
			self.walkAni:draw( self._sh.x - self._off.x,  - self.offset.y, 0, self.dir, 1)
		end
	elseif self.state == "stand" then
		if self.dir == 1 then			
			love.graphics.draw(self.standImg, 			-- img source
			0, 0,
			0, -self.dir, 1, 							-- rotation radians, scaling x, scaling y
			self._sh.x - self._off.x, self.offset.y)										-- offset
		else
			love.graphics.draw(self.standImg,
			0, 0,
			0, -self.dir, 1,
			0 + self._off.x, self.offset.y)
		end
	elseif self.state == "jump" then
		if self.dir == 1 then			
			love.graphics.draw(self.jumpImg, 			-- img source
			0, 0,
			0, -self.dir, 1, 							-- rotation radians, scaling x, scaling y
			self._sh.x - self._off.x, self.offset.y)										-- offset
		else
			love.graphics.draw(self.jumpImg,
			0, 0,
			0, -self.dir, 1,
			0 + self._off.x, self.offset.y)
		end
	end
	if nil ~= self.m then
			self.m:drawm(self)
	end
	love.graphics.pop()
	love.graphics.setColor(0xff, 0xff, 0xff, 0xff)

end

local function reset(self, new_x, new_y)
	self.pos = vector(new_x, new_y)
	self.startPos = self.pos:clone()
	self.vel = vector(0, 0)
	self.disp = vector(new_x, new_y)
	self.force = vector(0, 0)
end

local function domagic(self, type, time)
	if nil == self.m then
		--if self.magics[type] then
			if type == 'wind' then
				self.m = magus.initwii(self, type, time)
				audio:play(9, false, 1)
			elseif type == 'earth' then
				audio:play(10, false, 1)
				self.m = magus.initm(self, type, time)
			elseif type == 'water' then
				audio:play(8, false, 1)
				self.m = magus.initm(self, type, time)
			elseif type == 'fire' then
				audio:play(12, false, 1)
				self.m = magus.initm(self, type, time)
			elseif type == 'ice' then
				audio:play(11, false, 1)
				self.m = magus.initm(self, type, time)
			end
		--end
	end
end

function newHero(x, y)
	local _sh = vector(128, 64)	-- local var for shape dimensions
	local _off = vector(42, 0)
	return setmetatable( {
		_sh = _sh,
		_off = _off,
		-- position
		pos = vector(x, y),
		-- shape
		offset = vector(0, 10),
		shape = vector(44, 50),
		-- velocity vector of hero
		vel = vector(0,0),
		-- new position after physic calculation
		disp = vector(x or 100, y or 200),
		-- gravity constant of hero
		gravity = vector(0, 700),
		-- force that hero accumulates per frame
		force = vector(0,0),
		-- damping constant (aka friction)
		damp = 0.05,
		-- max time hero is invincible
		max_invic = 3,
		-- time passed since last hit
		hit_time = 0,
		max_jump = 1,
		jump_count = 0,
		jump_power = 500,
		type = 'hero',
		health = 3,
		max_health = 3,
		draw = draw,
		update = update,
		initm = initm,
		magics = {},
		domagic = domagic,
		reset = reset,
		gethit = gethit,
		get_jump_power = get_jump_power,
		sign = nil,
		
		-- animation
		--TODO - change animation speed
		state = "stand",		 -- other states "walk", "jump"
		walkAni = newAnimation(love.graphics.newImage(img..'hero_walk.png'), _sh.x, _sh.y, 0.15, 4),
		standImg = love.graphics.newImage(img..'hero_stand.png'),	
		jumpImg = love.graphics.newImage(img..'hero_jump.png'),
		dir = 1					-- hero direction, useful for animation
	}, {} )
end
